/*
 File: rules_use_cntsym.cpp
 Date and Time: Fri Jan 30 18:55:23 2015 
*/
#include "rules_use_cnt.h"
using namespace NS_yacco2_T_enum;// enumerate
using namespace NS_yacco2_err_symbols;// error symbols
using namespace NS_yacco2_k_symbols;// lrk 
using namespace NS_yacco2_terminals;// terminals
using namespace NS_yacco2_characters;// rc 
using namespace yacco2;// yacco2 library
using namespace NS_rules_use_cnt;// grammar's ns
// first set terminals
// monolithic grammar --- no thread
void 
Crules_use_cnt::reduce_rhs_of_rule
    (yacco2::UINT Sub_rule_no,yacco2::Rule_s_reuse_entry** Recycled_rule){
   int reducing_rule = rhs_to_rules_mapping_[Sub_rule_no];
   Per_rule_s_reuse_table* rule_reuse_tbl_ptr = 
        fsm_rules_reuse_table.per_rule_s_table_[reducing_rule];
   Rule_s_reuse_entry* re(0);
   find_a_recycled_rule(rule_reuse_tbl_ptr,&re);
   (*Recycled_rule) = re;
   fnd_re: switch (Sub_rule_no){
    case rhs1_Rrules_use_cnt_:{
       Rrules_use_cnt* sym;
     if(re->rule_ == 0){
       sym = new Rrules_use_cnt(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rrules_use_cnt*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     return;}
    case rhs1_Rrules_:{
       Rrules* sym;
     if(re->rule_ == 0){
       sym = new Rrules(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rrules*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     return;}
    case rhs2_Rrules_:{
       Rrules* sym;
     if(re->rule_ == 0){
       sym = new Rrules(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rrules*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     return;}
    case rhs1_Rrule_:{
       Rrule* sym;
     if(re->rule_ == 0){
       sym = new Rrule(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rrule*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     return;}
    case rhs1_Rrule_def_:{
       Rrule_def* sym;
     if(re->rule_ == 0){
       sym = new Rrule_def(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rrule_def*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     sym->sr1();
     return;}
    case rhs1_Rsubrules_:{
       Rsubrules* sym;
     if(re->rule_ == 0){
       sym = new Rsubrules(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rsubrules*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     return;}
    case rhs2_Rsubrules_:{
       Rsubrules* sym;
     if(re->rule_ == 0){
       sym = new Rsubrules(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rsubrules*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 3;
    

     return;}
    case rhs1_Rsubrule_:{
       Rsubrule* sym;
     if(re->rule_ == 0){
       sym = new Rsubrule(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rsubrule*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     return;}
    case rhs1_Rsubrule_def_:{
       Rsubrule_def* sym;
     if(re->rule_ == 0){
       sym = new Rsubrule_def(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rsubrule_def*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     sym->sr1();
     return;}
    case rhs1_Rsubrule_s_used_rules_epi_:{
       Rsubrule_s_used_rules_epi* sym;
     if(re->rule_ == 0){
       sym = new Rsubrule_s_used_rules_epi(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rsubrule_s_used_rules_epi*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 0;
    

     return;}
    case rhs2_Rsubrule_s_used_rules_epi_:{
       Rsubrule_s_used_rules_epi* sym;
     if(re->rule_ == 0){
       sym = new Rsubrule_s_used_rules_epi(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rsubrule_s_used_rules_epi*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     return;}
    case rhs1_Rsubrule_s_used_rules_:{
       Rsubrule_s_used_rules* sym;
     if(re->rule_ == 0){
       sym = new Rsubrule_s_used_rules(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rsubrule_s_used_rules*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     sym->sr1();
     return;}
    case rhs2_Rsubrule_s_used_rules_:{
       Rsubrule_s_used_rules* sym;
     if(re->rule_ == 0){
       sym = new Rsubrule_s_used_rules(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rsubrule_s_used_rules*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr2();
     return;}
    default: return;
   }
}
